## Intrusction of Reproducing Numerical Experiments in *AdaHSPG*
-----

### 1.NonConvex Experiments:

In **`nonconvex`** directory, we provide the source code of the tested optimizers in the submitted paper, i.e., **Prox-SG**, **Prox-SVRG**, **HSPG**, and **AdaHSPG+**, on solving the convex mixed l1/l2-regularized image classification problem via DNNs. 

To reproduce the numerical results in Section 4.2, run the following commands

####  Step 1. Train The Models:

```
python optimizer_name.py --lmbda [value] --dataset_name [cifar10/fashionmnist] --backend [vgg16/resnet18/mobilenet] --max_epoch [value]
```

For example

```
python proxsg.py --lmbda 0.001 --dataset_name fashionmnist --backend resnet18 --max_epoch 300
python proxsvrg.py --lmbda 0.001 --dataset_name cifar10 --backend vgg16 --max_epoch 300
```

#### Step 2. Check Numerical Experiments:

The numerical results from Step 1 will be automatically saved into **`results`** directory.

